SELECT 
    bibNumber,
    cout,
    cin,
    title,
    deweyClass,
    DATEDIFF(cin, cout) AS diff,
    ((MONTH(cout) - 1) * 30 + DAY(cout)) AS outDay,
    ((MONTH(cin) - 1) * 30 + DAY(cin)) AS inDay,
    YEAR(cout) AS outYear,
    YEAR(cin) AS inYear,
    (CASE
        WHEN (LOWER(title) LIKE '%python%') THEN 'Python'
        WHEN (LOWER(title) LIKE '%java %') THEN 'Java'
        WHEN (LOWER(title) LIKE '%javascript%') THEN 'JavaScript'
        WHEN (LOWER(title) LIKE '%sql%') THEN 'SQL'
        WHEN (LOWER(title) LIKE '% c %') THEN 'C'
    END) AS langType
FROM
    spl_2016.inraw
WHERE
    (LOWER(title) LIKE '%python%'
        OR LOWER(title) LIKE '%java%'
        OR LOWER(title) LIKE '%javascript%'
        OR LOWER(title) LIKE '% c %'
        OR LOWER(title) LIKE '%sql%')
        AND (deweyClass = ''
        OR (deweyClass > 0 AND deweyClass < 100))
        AND YEAR(cout) > 2000
        AND YEAR(cin) > 2000