import controlP5.*;
import peasy.*;
ControlP5 cp5;
PeasyCam cam;

Table table;
int numRows;
boolean showPython;
boolean showJava;
boolean showSQL;
boolean showJavaScript;
boolean showC;
float R = 50;
float H = 20;

ArrayList<Book> books = new ArrayList<Book>();

void setup(){
  size(800, 600, P3D);
  
  cp5 = new ControlP5(this);
  cam = new PeasyCam(this, 200); 
  
  table = loadTable("langType.csv", "header");
  numRows = table.getRowCount();
  
  for (int i=0; i<numRows;i++){
    String cout = table.getString(i, 1);
    String cin = table.getString(i, 2);
    String title = table.getString(i, 3);
    int diff = table.getInt(i, 5);
    int outDay = table.getInt(i, 6);
    int inDay = table.getInt(i, 7);
    int outYear = table.getInt(i, 8);
    int inYear = table.getInt(i, 9);
    String type = table.getString(i, 10);
    
    Book newBook = new Book(cout, cin, title, diff, outDay, inDay, outYear, inYear, type);
    books.add(newBook);
  }
  print(books.size());
  
  showPython = true;
  showJava = false;
  showSQL = false;
  showJavaScript = false;
  showC = false;
  
  cp5.addToggle("showPython");
  cp5.addToggle("showJava");
  cp5.addToggle("showSQL");
  cp5.addToggle("showJavaScript");
  cp5.addToggle("showC");
  
  cp5.addSlider("R")
  .setRange(0,100);
  cp5.addSlider("H")
  .setRange(0,50);

  cp5.setAutoDraw(false);
}

void draw(){
  background(0);
  
  //float R = 50;
  //float H = 20;
  
  // draw a circle  
  //for (int j=0;j<10;j++){
  //  pushMatrix();
  //  translate(0, 0, H*j);
  //  circle(0,0,R+10);
  //  popMatrix();
  //}
  
  for (int i=0;i<books.size();i++){
    Book theBook = books.get(i);
    float x1, y1, z1;
    float x2, y2, z2;
    float theta1, theta2;
    
    theta1 = theBook.outDay;
    theta2 = theBook.inDay;
    x1 = (float)Math.cos(theta1)*R;
    y1 = (float)Math.sin(theta1)*R;
    x2 = (float)Math.cos(theta2)*R;
    y2 = (float)Math.sin(theta2)*R;
    z1 = (theBook.outYear-2005)*H;
    z2 = (theBook.inYear-2005)*H;
    
    //pushMatrix();
    //translate(0, 0, -200);
    //line(x1, y1, z1, x2, y2, z2);
    //popMatrix();
    
    if (showPython==true & theBook.type.equals("Python")){
      line(x1, y1, z1, x2, y2, z2);
    }
    else if(showJava==true & theBook.type.equals("Java")){
      line(x1, y1, z1, x2, y2, z2);
    }
    else if(showSQL==true & theBook.type.equals("SQL")){
      line(x1, y1, z1, x2, y2, z2);
    }
    else if(showJavaScript==true & theBook.type.equals("JavaScript")){
      line(x1, y1, z1, x2, y2, z2);
    }
    else if(showC==true & theBook.type.equals("C")){
      line(x1, y1, z1, x2, y2, z2);
    }
    
    //theta = map(inDay, 0, 365, 0, 360)
    color c = #FFFFFF;
    stroke(c);
    float weight;
    if (theBook.diff>100){
      weight = 0.2;
    }
    else{
      weight = 0.1 + theBook.diff/1000;
    }
    strokeWeight(weight);
    //strokeWeight(0.1);
    //strokeWeight(100/(theBook.diff+1));
    
    
    float k, b;
    double d;
    k = (y2-y1)/(x2-x1);
    b = (x2*y1-x1*y2)/(x2-x1);
    double tmp1 = k*mouseX-mouseY+b;
    double tmp2 = (double)k*k+1;
    d = Math.abs(tmp1)/Math.sqrt(tmp2);
    
    if (d < 0.1){
      //text(theBook.title,100,100,100);
      fill(255);
      stroke(#FF0000);
      strokeWeight(2);
      textSize(12);
      //text(theBook.title,mouseX,mouseY,100);
      //text(theBook.title,x1,y1,z1);
      text(theBook.title,R,R,z1);
      pushMatrix();
      //translate(mouseX,mouseY,100);
      //translate(x1,y1,z1);
      translate(R,R,z1);
      scale(0.1);
      //textAlign(LEFT, CENTER);
      //text(theBook.title,10,0,0);
      popMatrix();
    }
  }
  gui();
}

void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}
